
do '../web-lib.pl';
&init_config();
ReadParse();

use XML::Parser;


my $tfwlib = '/usr/lib/simplefirewall.pm';
if( ! -f $tfwlib ) {
	error( 'Turtle Firewall Library not found. Install Turtle Firewall.' );
}
require $tfwlib;

$fw = new SimpleFirewall;
$fw->LoadFirewall( $config{fw_file} );

my $fwFile;
my $servicesFile;

if( $fwFile eq '' ) { $fwFile = "/etc/webmin/simplefirewall/fw.xml"; }
if( $servicesFile eq '' ) { $servicesFile = "/etc/webmin/simplefirewall/fwservices.xml"; }

$net_scripts_dir = "/etc/sysconfig/network-scripts";
$network_config = "/etc/sysconfig/network";
$static_route_config = "/etc/sysconfig/static-routes";
$sysctl_config = "/etc/sysctl.conf";

# active_interfaces()
# Returns a list of currently ifconfig'd interfaces
sub active_interfaces
{
local(@rv, @lines, $l);
open(IFC, "ifconfig -a |");
while(<IFC>) {
	s/\r|\n//g;
	if (/^\S+/) { push(@lines, $_); }
	else { $lines[$#lines] .= $_; }
	}
close(IFC);
foreach $l (@lines) {
	local %ifc;
	$l =~ /^([^:\s]+)/; $ifc{'name'} = $1;
	$l =~ /^(\S+)/; $ifc{'fullname'} = $1;
	if ($l =~ /^(\S+):(\d+)/) { $ifc{'virtual'} = $2; }
	if ($l =~ /inet addr:(\S+)/) { $ifc{'address'} = $1; }
	elsif (!$_[0]) { next; }
	if ($l =~ /Mask:(\S+)/) { $ifc{'netmask'} = $1; }
	if ($l =~ /Bcast:(\S+)/) { $ifc{'broadcast'} = $1; }
	if ($l =~ /HWaddr (\S+)/) { $ifc{'ether'} = $1; }
	if ($l =~ /MTU:(\d+)/) { $ifc{'mtu'} = $1; }
	$ifc{'up'}++ if ($l =~ /\sUP\s/);
	$ifc{'edit'} = ($ifc{'name'} !~ /^ppp/);
	$ifc{'index'} = scalar(@rv);
	push(@rv, \%ifc);
	}
return @rv;
}




# iface_type(name)
# Returns a human-readable interface type name
sub iface_type
{
    return "PPP" if ($_[0] =~ /^ppp/);
    return "SLIP" if ($_[0] =~ /^sl/);
    return "PLIP" if ($_[0] =~ /^plip/);
    return "Ethernet" if ($_[0] =~ /^eth/);
    return "Arcnet" if ($_[0] =~ /^arc/);
    return "Token Ring" if ($_[0] =~ /^tr/);
    return "Pocket/ATP" if ($_[0] =~ /^atp/);
    return "Loopback" if ($_[0] =~ /^lo/);
    return $text{'ifcs_unknown'};
}


sub iptables_module_run
{
    return `/sbin/iptables -V`;
}

sub ipchains_module_run
{
    return `/sbin/ipchains -V`;
}

sub module_run_now
{
    return $text{'info-ipchains-install'} if(`/sbin/ipchains -L` =~ /^Chain/);
    return $text{'info-iptables-install'} if(`/sbin/iptables -L` =~ /^Chain/);

} 

sub info_additional
{
    return $text{'info-kernel-version-up'} if(`/bin/uname -r` =~ /^2.4/);
    return $text{'info-kernel-version-down'} if(`/bin/uname -r` =~ /^2.2/);
}

sub info_display_rules
{
    return `/sbin/iptables -L -n`;
}

sub info_display_rules_nat
{
    return `/sbin/iptables -t nat -L -n`;
}



sub AddRule 
{
	my ($src, $dst, $service, $port) = @_;
	my %attr = ( 
		     'SRC' => [$src], 
		     'DST' => [$dst], 
		     'SERVICE'=> [$service], 
		     'PORT'=> [$port]
		     );
	
}

sub SaveFirewallAs 
{
    my ($source, $destination, $service, $port) = @_;
    my %attr = ( 
		     'src' => [$source], 
		     'dst' => [$destination], 
		     'service'=> [$service], 
		     'port'=> [$port]
		     );
    
    
	
    my $xml = "<firewall>\n";
    $xml .= "\n";
    for my $i (0..1) {
	$xml .= &attr2xml( 'rule', %attr );
    }
    $xml .= "\n";
    $xml .= "</firewall>\n";
    
    open( FWFILE, ">$fwFile" );
    print FWFILE $xml;
    close( FWFILE );
}


sub attr2xml 
{
    my ($tag,%attr) = @_;
    my $appo = "<$tag";
    
    for $attribute (keys %attr){
	$appo .= " $attribute=@{ $attr{$attribute}} ";
    }
    
    $appo .= "/>\n";
    return $appo;
}








1;










